/**************************************************/
/*  MTU2gK@̂P                      */
/**************************************************/

#include "iodefine.h"
#include "typedefine.h"

#define ex2

#define	printf	((int (*)(const char *,...))0x00007c7c)

#define	SW6 	(PD.DR.BIT.B18)
#define	SW5 	(PD.DR.BIT.B17)
#define	SW4 	(PD.DR.BIT.B16)

#define	LED6	(PE.DR.BIT.B11)
#define	LED_ON	(0)
#define	LED_OFF	(1)

#define  SPK	(PE.DR.BIT.B0)

#define LCD_RS		(PA.DR.BIT.B22)
#define LCD_E		(PA.DR.BIT.B23)
#define LCD_RW		(PD.DR.BIT.B23)
#define LCD_DATA	(PD.DR.BYTE.HH)

void wait_us(_UINT);
void LCD_inst(_SBYTE);
void LCD_data(_SBYTE);
void LCD_cursor(_UINT, _UINT);
void LCD_putch(_SBYTE);
void LCD_putstr(_SBYTE *);
void LCD_cls(void);
void LCD_init(void);

// --------------------
// -- gp֐Q --
// --------------------
void wait_us(_UINT us) {
	_UINT val;

	val = us * 10 / 16;
	if (val >= 0xffff)
		val = 0xffff;

	CMT0.CMCOR = val;
	CMT0.CMCSR.BIT.CMF &= 0;
	CMT.CMSTR.BIT.STR0 = 1;
	while (!CMT0.CMCSR.BIT.CMF);
	CMT0.CMCSR.BIT.CMF = 0;
	CMT.CMSTR.BIT.STR0 = 0;
}

void LCD_inst(_SBYTE inst) {
	LCD_E = 0;
	LCD_RS = 0;
	LCD_RW = 0;
	LCD_E = 1;
	LCD_DATA = inst;
	wait_us(1);
	LCD_E = 0;
	wait_us(40);
}

void LCD_data(_SBYTE data) {
	LCD_E = 0;
	LCD_RS = 1;
	LCD_RW = 0;
	LCD_E = 1;
	LCD_DATA = data;
	wait_us(1);
	LCD_E = 0;
	wait_us(40);
}

void LCD_cursor(_UINT x, _UINT y) {
	if (x > 15)
		x = 15;
	if (y > 1)
		y = 1;
	LCD_inst(0x80 | x | y << 6);
}

void LCD_putch(_SBYTE ch) {
	LCD_data(ch);
}

void LCD_putstr(_SBYTE *str) {
	_SBYTE ch;

	while (ch = *str++)
		LCD_putch(ch);
}

void LCD_cls(void) {
	LCD_inst(0x01);
	wait_us(1640);
}

void LCD_init(void) {
	wait_us(45000);
	LCD_inst(0x30);
	wait_us(4100);
	LCD_inst(0x30);
	wait_us(100);
	LCD_inst(0x30);
	
	LCD_inst(0x38);
	LCD_inst(0x08);
	LCD_inst(0x01);
	wait_us(1640);
	LCD_inst(0x06);
	LCD_inst(0x0c);
}


// -- C֐ --
void main()
{
#ifdef ex2
	// -- KQ --
	STB.CR4.BIT._MTU2 = 0;
	PFC.PEIORL.BIT.B0 = 1;

#endif

#ifdef ex3
	// -- KR --
	int i;

	STB.CR4.BIT._MTU2 = 0;
	PFC.PEIORL.BIT.B11 = 1;

	for (i = 0; i < 10; i++) {
	}
#endif

#ifdef ex4
	// -- KS --
	int i;

	STB.CR4.BIT._MTU2 = 0;
	PFC.PEIORL.BIT.B11 = 1;

#endif

#ifdef ex5
	// -- KT --
	int count;

	STB.CR4.BIT._MTU2 = 0;
	STB.CR4.BIT._CMT = 0;

	CMT0.CMCSR.BIT.CKS = 1;

#endif

#ifdef ex6
	// -- KU --
	int count;

	STB.CR4.BIT._MTU2 = 0;
	STB.CR4.BIT._CMT = 0;

	CMT0.CMCSR.BIT.CKS = 1;

#endif
}
